package com.jasamedika.medifirst2000.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import com.jasamedika.medifirst2000.constants.Constants;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.core.web.WebConstants;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.PelatihanPaketService;
import com.jasamedika.medifirst2000.util.rest.RestUtil;
import com.jasamedika.medifirst2000.vo.PelatihanPaketVO;

@RestController
@RequestMapping("/pelatihan-paket")
public class PelatihanPaketController extends LocaleController {
	
	@Autowired
	private PelatihanPaketService pelatihanPaketService;
	
	private static final Logger LOGGER = LoggerFactory.getLogger(CssdBmhpController.class);
	

	@RequestMapping(value = "/save-pelatihan-paket/", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> savePelatihanPaket(@Valid @RequestBody PelatihanPaketVO vo,HttpServletRequest request,HttpServletResponse response) {
		
		try {
			Map<String, Object> result = pelatihanPaketService.savePelatihanPaket(vo);
			if (null != result)
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS, request));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when save Permintaan Perbaikan", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when save Permintaan Perbaikan", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}

	}
	
	@SuppressWarnings("unchecked")
	@RequestMapping(value = "/daftar-komponen")
	@ResponseBody
	public Map<String, Object> daftarKomponen() {
		Map<String, Object> resultPageMap = pelatihanPaketService.daftarKomponen();
		return resultPageMap;
	}
	
	@SuppressWarnings("unchecked")
	@RequestMapping(value = "/list-pelatihan-paket")
	@ResponseBody
	public Map<String, Object> listBarangBmhp(
			@RequestParam(value = "page", required = false, defaultValue = "0") Integer page,
			@RequestParam(value = "take", required = false, defaultValue = "10000000") Integer limit,
			@RequestParam(value = "sort", required = false, defaultValue = "id") String sort,
			@RequestParam(value = "dir", required = false, defaultValue = "asc") String dir,
			@RequestParam(value = "tanggalAwal", required = false) String tanggalAwal,
			@RequestParam(value = "tanggalAhir", required = false) String tanggalAhir) {

		Map<String, Object> resultPageMap = pelatihanPaketService.listPelatihanPaket(page,limit,sort,dir,tanggalAwal,tanggalAhir);

		return resultPageMap;
	}
	
	// Menampilkan Kartu Pengendali Berdasarkan Norec (array)
	@RequestMapping(value = "/detail-pelatihan-paket", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
	public Map<String, Object> detailPelatihanPaket(
			@RequestParam(value = "strukPlanningId", required = true) String strukPlanningId,
			@RequestParam(value = "produkId", required = true) Integer produkId) {
		Map<String, Object> result = pelatihanPaketService.detailPelatihanPaket(strukPlanningId,produkId);

		return result;
	}
	
	
	
}
